#ifndef ETA_FILE_H
#define ETA_FILE_H

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <time.h>
#include "matrix.h"

#define ETA_MAX 128

//typedef long long my_clock_t;
typedef clock_t my_clock_t;

typedef struct {
  int lp_rows;
  int k;  // update 
  int s;  // Ls ο
  int *P;
  eta_matrix** L;
  eta_singleton** Ls;
  eta_matrix_d** L_d;
  eta_singleton_d** Ls_d;
  matrix* U;
  vector_d** U_d;
  permutation_matrix* Q;
  permutation_matrix* R;
  my_clock_t init_time;
  my_clock_t last_time;
} eta_file;

eta_file* new_eta_file(int lp_rows);
void eta_file_free(eta_file* ef);
void eta_file_btran(eta_file* ef, vector* c, vector* y);
void eta_file_ftran(eta_file* ef, vector* b, vector* x, vector* w);

void eta_file_btran_d(eta_file* ef, vector_d* c, vector_d* y);
void eta_file_ftran_d(eta_file* ef, vector_d* b, vector_d* x);

#endif
