let lp = Exlp.lp_create();;
Exlp.lp_set_verbose lp true;;

Exlp.lp_set_obj_name lp "obj";;
Exlp.lp_add_row lp "row1";;
Exlp.lp_add_row lp "row2";;
let x = Exlp.lp_add_var_without_a lp "x"
and y = Exlp.lp_add_var_without_a lp "y";;

let obj = Exlp.lp_get_row_num lp "obj"
and row1= Exlp.lp_get_row_num lp "row1"
and row2= Exlp.lp_get_row_num lp "row2";;

Exlp.lp_set_row_equality lp row1 'E';;
Exlp.lp_set_row_equality lp row2 'L';;

Exlp.lp_matrix_adjust_size lp;;

Printf.printf "%d %d %d %d %d\n" x y row1 row2 obj;;

Exlp.lp_set_coefficient lp (Gmp.Q.from_si 0 1) row1 x;;
Exlp.lp_set_coefficient lp (Gmp.Q.from_si 1 1) row1 y;; 
Exlp.lp_set_coefficient lp (Gmp.Q.from_si 1 1) row2 x;;
Exlp.lp_set_coefficient lp (Gmp.Q.from_si 2 1) row2 y;; 
Exlp.lp_set_coefficient lp (Gmp.Q.from_si 1 1) obj y;;

Exlp.lp_set_maximize lp false;;

Exlp.lp_set_rhs lp row1 (Gmp.Q.from_si 2 1);;
Exlp.lp_set_rhs lp row2 (Gmp.Q.from_si 5 1);;

match Exlp.solve_lp lp with
| Exlp.LP_RESULT_OPTIMAL ->
    Printf.printf "satisfiable, objective = %s x = %s y = %s\n"
      (Gmp.Q.to_string (Exlp.lp_get_object_value lp))
      (Gmp.Q.to_string (Exlp.lp_get_solution lp x))
      (Gmp.Q.to_string (Exlp.lp_get_solution lp y))
| Exlp.LP_RESULT_UNBOUNDED ->
  print_endline "unbounded"
| Exlp.LP_RESULT_INFEASIBLE ->
  print_endline "infeasible"
| Exlp.LP_RESULT_DUAL_INFEASIBLE ->
  print_endline "dual infeasible"
| Exlp.LP_RESULT_UNSUPPORTED ->
  print_endline "unsupported";;
