open Linear_prog
open Gmp

let problem = {
  constraints =
    [ [ "y", (Q.from_int 3)], EQUAL, (Q.from_int 2);
      [ "x", (Q.from_int 1); "y", (Q.from_int 2) ], LESS_EQ, (Q.from_int 5) ];
  objective = [ "x", (Q.from_int 1) ];
  direction = Linear_types.MAXIMIZATION;
  bounds = [ ] };;

match solve problem with
| RESULT_OPTIMAL(optimum, solution) ->
    (Printf.printf "satisfiable, optimum=%s\n" (Q.to_string optimum);
    Hashtbl.iter (fun name (value, minimum, maximum) ->
      Printf.printf "%s = %s in (%s, %s)\n" name (Q.to_string value)
		 (match minimum with None -> "-inf" | Some x -> Q.to_string x)
		 (match maximum with None -> "+inf" | Some x -> Q.to_string x))
       solution)
| RESULT_UNBOUNDED ->
  print_endline "unbounded"
| RESULT_INFEASIBLE ->
  print_endline "infeasible"
| RESULT_DUAL_INFEASIBLE ->
  print_endline "dual infeasible"
| RESULT_UNSUPPORTED ->
  print_endline "unsupported";;
